import pygame


joysticks = None

JOYSTICK_TOLERANCE = 0.3

def init():
    global joysticks
    pygame.joystick.init()
    joysticks = [pygame.joystick.Joystick(x) for x in xrange(pygame.joystick.get_count())]
    for j in joysticks:
        j.init()

def keys():
    return pygame.key.get_pressed()

def x():
    x = 0
    for j in joysticks:
        axis = j.get_axis(0)
        if abs(axis) >= JOYSTICK_TOLERANCE:
            if axis > 0: x += 1
            else:        x -= 1
    if keys()[pygame.K_LEFT]: x -= 1
    if keys()[pygame.K_a]: x -= 1
    if keys()[pygame.K_RIGHT]: x += 1
    if keys()[pygame.K_d]: x += 1
    return x

def y():
    y = 0
    for j in joysticks:
        axis = j.get_axis(1)
        if abs(axis) >= JOYSTICK_TOLERANCE:
            if axis > 0: y += 1
            else:        y -= 1
    if keys()[pygame.K_UP]: y -= 1
    if keys()[pygame.K_w]: y -= 1
    if keys()[pygame.K_DOWN]: y += 1
    if keys()[pygame.K_s]: y += 1
    return y

def jump():
    for j in joysticks:
        if j.get_button(0):
            return True
    if keys()[pygame.K_c]: return True
    return False

def is_pause(ev):
    return ((ev.type == pygame.KEYDOWN and ev.key == pygame.K_z) or
            (ev.type == pygame.JOYBUTTONDOWN and ev.button == 1))

def is_action(ev):
    return ((ev.type == pygame.KEYDOWN and ev.key == pygame.K_x) or
            (ev.type == pygame.JOYBUTTONDOWN and ev.button == 2))

def show_collision_rects():
    return keys()[pygame.K_F10]

def is_show_collision_rects(ev):
    return (ev.type == pygame.KEYDOWN or ev.type == pygame.KEYUP) and\
        ev.key == pygame.K_F10
