import os
import pygame
import pygame.mixer as mixer


sounds = {}

_snd_defs = [
    'crash.wav',
    'explosion.wav',
    'hurt.wav',
    'jump.wav',
    'death.wav',
    'bounce.wav',
    'WilhelmScream.wav',
]


def _try_play(fname):
    mixer.music.load(os.path.join('assets',fname))
    mixer.music.play()
    print 'Playing',fname

def play_music(name):
    try:
        _try_play(name+'.mp3')
    except pygame.error:
        # Maybe MP3s aren't supported here? Try OGG instead
        # Note that OGG support on Mac is sketchy so we still need MP3s!
        _try_play(name+'.ogg')
    
def play_main_music():
    play_music('music')

def stop_music():
    mixer.music.stop()

def play_gameover_music():
    play_music('gameover')

def init():
    mixer.init()
    for fname in _snd_defs:
        sounds[fname] = mixer.Sound(os.path.join('assets',fname))

