import pygame
from pygame.sprite import Sprite,DirtySprite
from pygame.locals import *

from util import loadimg


sheets = {}

_sheet_defs = [
    # filename, width, height, offset-x, offset-y
    ('generic_character_ss.png', 22, 50, 0, 0),
    ('generic_death_ss.png', 44, 50, 0, 0),
    ('antichrist_death_ss.png', 44, 50, 0, 0),
    ('shadow_character_ss.png', 22, 50, 0, 0),
    ('antichrist_character_ss.png', 22, 50, 0, 0),
    ('billboard_ss.png', 128, 92, 0, 0),
    ('bird.png', 5, 5, 0, 0),
    ('car_ss.png', 153, 78, 0, 0),
    ('cellar_door_ss.png', 50, 30, 0, 0),
    ('cloud.png', 10, 5, 0, 0),
    ('combo.png', 50, 50, 0, 0),
    ('explosion.png', 50, 50, 0, 0),
    ('flowers_ss.png', 15, 30, 0, 0),
    ('plane.png', 10, 5, 0, 0),
    ('pow.png', 50, 50, 0, 0),
    ('propane_tank_ss.png', 20, 21, 0, 0),
    ('shop_sign_ss.png', 24, 25, 0, 0),
    ('streetlight_ss.png', 41, 141, 0, 0),
    ('trashcan_ss.png', 22, 23, 0, 0),
    ('tree_ss.png', 52, 98, 0, 0),
    ('wheelie_bin_ss.png', 21, 36, 0, 0),
    ('explosion.png', 50, 50, 0, 0),
]

class _SheetDef(object):
    def __init__(self,fname,width,height,offsx,offsy):
        self.fname = fname
        self.width = width
        self.height = height
        self.offsx = offsx
        self.offsy = offsy
    def load(self):
        return Spritesheet(loadimg(self.fname), self)


class Spritesheet(object):
    def __init__(self, image, shdef):
        self.image = image
        self.shdef = shdef

    @property
    def cols(self):
        return self.image.get_rect().width / self.shdef.width
    @property
    def rows(self):
        return self.image.get_rect().height / self.shdef.height

    def __getitem__(self,*args):
        if isinstance(args[0],list) or isinstance(args[0],tuple):
            ix = args[0][0]
            iy = args[0][1]
        else:
            ix = args[0]
            iy = args[1]
        r = Rect(
            ix * self.shdef.width + self.shdef.offsx,
            iy * self.shdef.height + self.shdef.offsy,
            self.shdef.width,
            self.shdef.height)
        return self.image.subsurface(r)

def init():
    for row in _sheet_defs:
        shdef = _SheetDef(*row)
        sheets[shdef.fname] = shdef.load()
